/* ---------- */
/* najihelp.c */
/* ---------- */

/* najitool help */

/* this  .c  is a part of */
/* najitool version 0.5.0 */

/* from najitool version 0.2.0 and */
/* above najitool will use libnaji */
/* this version uses libnaji 0.3.0 */

/* both najitool and libnaji */
/* are public domain and are */
/* made by the same author   */
/* please read license.txt   */

/* made by NECDET COKYAZICI  */


#include "libnaji.h"

void najitool_help_commands_1(void)
{
printf("\n");

printf("    kitten      cat_text    freverse    repcat      copyfile \n\n");
printf("    bin2text    bin2hexi    rndbfile    rndtfile    skipcat  \n\n");
printf("    skipchar    onlychar    repchar     eng2arab    arab2eng \n\n");
printf("    8bit256     bigascii    bigascif    copyself    bin2c    \n\n");
printf("    calc        genlic      license     database    html_db  \n\n");
printf("    addim       allfiles    dos2unix    unix2dos    compare  \n\n");
printf("    ccompare    charfile    hmakerf     hmaker      filechop \n\n");
printf("    txt2html    htmlfast    tabspace    unihtml     rmunihtm \n\n");
printf("    mergline    lcharvar    rcharvar    asctable    hexicat  \n\n");
printf("    onlycat     najcrypt    engnum      turnum      repcharp \n\n");

}

void najitool_help_commands_2(void)
{
printf("\n");

printf("    repcatpp    fillfile    rndffill    strfile     zerokill \n\n");
printf("    randkill    najisum     rndbsout    rndtsout    putlines \n\n");
printf("    naji_bmp    coffset     copyoffs    revcat      qcrypt   \n\n");
printf("    revlines    flipcopy                                     \n\n");
printf("                                                             \n\n");


}


void najitool_help_examples_1(void)
{

printf("\n");

printf("kitten    readme.txt\n");
printf("cat_text  a.out\n");

printf("freverse  readme.txt  emdear.txt\n");
printf("repcat    hmm.txt  3\n");
printf("copyfile  license.txt  lbackup.txt\n");
printf("bin2text  file.bin  file.txt\n");
printf("bin2hexi  DigiTvOS.bin  DigiTvOS.hex\n");
printf("rndbfile  random.bin  5435346\n");
printf("rndtfile  random.txt  5435346\n");
printf("skipcat   readme.txt  \"#$&*\"\n");

printf("skipchar  readme.txt  readme2.txt  \"#$&*\"\n");
printf("onlychar  readme.txt  abc.txt \"abc\"\n");
printf("repchar   hello.wav  helloslow.wav  1\n");

printf("eng2arab  english.txt arabiyya.txt\n");
printf("arab2eng  arabi.txt  eng.txt\n");

printf("8bit256   ten.bin 10\n");

printf("bigascii  hello\n");
printf("bigascif  hello  hello.txt\n");

printf("copyself  naji2\n");

printf("bin2c     mypic.bmp mypic.c my_pic_array\n");

printf("\n");

return;
}

void najitool_help_examples_2(void)
{
printf("\n");

printf("calc\n");
printf("genlic\n");
printf("license\n");
printf("database\n");
printf("html_db\n");

printf("addim 12\n");
printf("allfiles 4\n");

printf("dos2unix  hello.txt HELLO\n");
printf("unix2dos  BYE  bye.txt\n");

printf("compare   hi.txt  hello.txt\n");
printf("ccompare  a.out   a.bin\n");
printf("charfile  aaa.txt 1000 a\n");

printf("hmakerf  mycode.c mycode.h\n");
printf("hmaker   mycode.c\n");

printf("filechop  2000000000 hello.vob  hello1.vob  hello2.vob\n");
printf("txt2html  readme.txt   readme.htm\n");
printf("htmlfast  asciiart.txt asciiart.html\n");
printf("tabspace 4 hello.txt hi_notab.txt\n");
printf("unihtml\n");
printf("rmunihtm\n");

printf("\n");
}

void najitool_help_examples_3(void)
{
printf("\n");

printf("mergline  namlower.txt  namupper.txt  rename.sh  \"mv -i \"  \"\"\n");
printf("lcharvar \"hello world\"\n");
printf("rcharvar \"hello world\"\n");
printf("asctable\n");
printf("hexicat   a.out\n");
printf("onlycat   readme.txt \"abc\"\n");
printf("najcrypt\n");
printf("engnum\n");
printf("turnum\n");
printf("repcharp  hi.wav  hislower.wav  1\n");
printf("repcatpp  hmmmmmmm.txt  3\n");
printf("fillfile  hello.txt   x\n");
printf("rndffill  todelete.txt\n");
printf("strfile   what.txt  11  \"what is this?\"\n");
printf("zerokill  secret.txt\n");
printf("randkill  secret.txt\n");
printf("najisum   checksum.txt\n");
printf("rndbsout  100\n");
printf("rndtsout  64\n");
printf("putlines  input.txt  output.txt \"hello\" \"world\"\n");
printf("\n");
}


void najitool_help_examples_4(void)
{
printf("\n");


printf("naji_bmp\n");
printf("coffset   a.out  30  213\n");
printf("copyoffs  a.out  10  345  a.bin\n");
printf("revcat    reverse.txt\n");
printf("qcrypt    secret.txt  what.txt\n");
printf("revlines  input.txt   output.txt\n");
printf("flipcopy  hi.txt  hifliped.txt\n");

printf("\n");
}





void najitool_command_help(char *cmd)
{

if (!strcmp(cmd, "kitten"))
{
printf("\n");
printf("kitten   - shows the contents of a file to the screen.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "cat_text"))
{
printf("\n");
printf("cat_text - shows only the text of a file to screen skiping\n");
printf("           binary characters.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "freverse"))
{
printf("\n");
printf("freverse - makes a reversed copy of the file, the start of\n");
printf("           the file becomes the end of the file and vice versa.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "repcat"))
{
printf("\n");
printf("repcat   - repeats each character in a file the number of times\n");
printf("           you specify to the screen.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "copyfile"))
{
printf("\n");
printf("copyfile - copies a file.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "bin2text"))
{
printf("\n");
printf("bin2text - makes a copy of the file you specify with only the\n");
printf("           text of the file skipping binary characters.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "bin2hexi"))
{
printf("\n");
printf("bin2hexi - dumps the file you specify in hexidecimal to a new file.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "rndbfile"))
{
printf("\n");
printf("rndbfile - generates a file with random characters from\n");
printf("           value 0 to 255 at the size you specify.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "rndtfile"))
{
printf("\n");
printf("rndtfile - generates a file with random text characters\n");
printf("           at the size you specify.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "skipcat"))
{
printf("\n");
printf("skipcat  - shows the contents of a file to the screen\n");
printf("           skipping the characters you specify.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "skipchar"))
{
printf("\n");
printf("skipchar - makes a copy of the file you specify skipping\n");
printf("           the characters you specify.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "onlychar"))
{
printf("\n");
printf("onlychar - makes a copy of the file you specify using only\n");
printf("           the characters you specify.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "repchar"))
{
printf("\n");
printf("repchar  - repeats each character in the file you specify the\n");
printf("           number of times you specify to a new file.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "eng2arab"))
{
printf("\n");
printf("eng2arab - English to Arabic transliteration system. Makes Arabic\n");
printf("           letters out of English letters. Download the transliteration\n");
printf("           table from http://najitool.sf.net/ for details.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "arab2eng"))
{
printf("\n");
printf("arab2eng - Arabic to English transliteration system. Makes English\n");
printf("           letters out of Arabic letters. Download the transliteration\n");
printf("           table from http://najitool.sf.net/ for details.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "8bit256"))
{
printf("\n");
printf("8bit256  - makes a file with the character values 0 to 255 from\n");
printf("           start to finish the number of times you sepcify.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "bigascii"))
{
printf("\n");
printf("bigascii - shows big ASCII art version of the word or sentence you\n");
printf("           specify to the screen.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "bigascif"))
{
printf("\n");
printf("bigascif - makes a file with big ASCII art text out of the word or\n");
printf("           sentence you specify.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "copyself"))
{
printf("\n");
printf("copyself - copies the najitool program to a new name.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "bin2c"))
{
printf("\n");
printf("bin2c    - makes a compilable C programming language source code file\n");
printf("           out of any file with the contents of the file in an array.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "calc"))
{
printf("\n");
printf("calc     - a calculator.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "genlic"))
{
printf("\n");
printf("genlic   - generates the najitool and libnaji license.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "license"))
{
printf("\n");
printf("license  - shows the najitool and libnaji license to the screen.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "database"))
{
printf("\n");
printf("database - makes a text file with a list of people and their details.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "html_db"))
{
printf("\n");
printf("html_db  - makes a HTML file with a list of people and their details.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "addim"))
{
printf("\n");
printf("addim    - makes a multipliction square at the size you specify.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "allfiles"))
{
printf("\n");
printf("allfiles - generates every single file ever possible to exist\n");
printf("           at a size you specify.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "dos2unix"))
{
printf("\n");
printf("dos2unix - converts DOS/Windows text files to UNIX format.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "unix2dos"))
{
printf("\n");
printf("unix2dos - converts UNIX text files to DOS/Windows format.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "compare"))
{
printf("\n");
printf("compare  - compares two files.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "ccompare"))
{
printf("\n");
printf("ccompare - compares two files and still continues when differences\n");
printf("           are encountered.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "charfile"))
{
printf("\n");
printf("charfile - makes a file containing a single character you specify the\n");
printf("           amount of times you specify.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "hmakerf"))
{
printf("\n");
printf("hmakerf  - makes a .h file with the function prototypes of a .c file.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "hmaker"))
{
printf("\n");
printf("hmaker   - makes function prototypes of a .c and shows to the screen.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "filechop"))
{
printf("\n");
printf("filechop - splits a file into two new files at the offset you specify.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "txt2html"))
{
printf("\n");
printf("txt2html - makes a HTML file out of a text file.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "htmlfast"))
{
printf("\n");
printf("htmlfast - makes a HTML file out of a text file preserving the spaces.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "tabspace"))
{
printf("\n");
printf("tabspace - converts tabs to spaces with the number of spaces for\n");
printf("           a tab you specify.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "unihtml"))
{
printf("\n");
printf("unihtml  - generates HTML pages with every possible Unicode letter/symbol.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "rmunihtm"))
{
printf("\n");
printf("rmunihtm - deletes the files that unihtml generates.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "mergline"))
{
printf("\n");
printf("mergline - merges the lines of two files into a new file and lets you\n");
printf("           specify text that comes at the beggining and end of each line.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "lcharvar"))
{
printf("\n");
printf("lcharvar - shows every single combination variation of a sentence or word\n");
printf("           starting from the left to the screen.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "rcharvar"))
{
printf("\n");
printf("rcharvar - shows every single combination variation of a sentence or word\n");
printf("           starting from the right to the screen.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "asctable"))
{
printf("\n");
printf("asctable - shows an ASCII table and the decimal, hexidecimal, and binary\n");
printf("           values on each line of it from values 32 to 126.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "hexicat"))
{
printf("\n");
printf("hexicat  - dumps the file you specify in hexidecimal to screen with the\n");
printf("           displayable text characters on the right.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "onlycat"))
{
printf("\n");
printf("onlycat  - shows the contents of the file you specify\n");
printf("           using only the characters you specify.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "najcrypt"))
{
printf("\n");
printf("najcrypt - naji interactive encryption/decryption function.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "engnum"))
{
printf("\n");
printf("engnum   - a list of numbers in English words from 1 to 9999.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "turnum"))
{
printf("\n");
printf("turnum   - a list of numbers in Turkish words from 1 to 9999.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "repcharp"))
{
printf("\n");
printf("repcharp - give it a start value and it repeats each character in a\n");
printf("           file then repeats the next character in the file more amount\n");
printf("           of times than the previous character to a new file.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "repcatpp"))
{
printf("\n");
printf("repcatpp - give it a start value and it repeats each character in a\n");
printf("           file then repeats the next character in the file more amount\n");
printf("           of times than the previous character to the screen.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "fillfile"))
{
printf("\n");
printf("fillfile - changes every character in a file to the character you specify.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "rndffill"))
{
printf("\n");
printf("rndffill - changes every character in a file to a random character.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "strfile"))
{
printf("\n");
printf("strfile  - makes a file out of a string (word or sentence) and repeats the\n");
printf("           string in the file that is made the number of times you specify.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "zerokill"))
{
printf("\n");
printf("zerokill - changes every character in a file to the hexidecimal value 00\n");
printf("           and then deletes it, this is good for secure deletion.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "randkill"))
{
printf("\n");
printf("randkill - changes every character in a file to a random character\n");
printf("           and then deletes it, this is good for secure deletion.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "najisum"))
{
printf("\n");
printf("najisum  - naji checksum function.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "rndbsout"))
{
printf("\n");
printf("rndbsout - puts random characters from value 0 to 255 to the standard output\n");
printf("           (usually the screen) at the size you specify.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "rndtsout"))
{
printf("\n");
printf("rndtsout - puts random text characters to the standard output\n");
printf("           (usually the screen) at the size you specify.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "putlines"))
{
printf("\n");
printf("putlines - makes a copy of the file you specify with text you specify for\n");
printf("           the beggining and end of each line.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "naji_bmp"))
{
printf("\n");
printf("naji_bmp - generates lots of predefined .BMP file images.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "coffset"))
{
printf("\n");
printf("coffset  - shows the characters in a file from the offset (start and end)\n");
printf("           you specify to the screen.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "copyoffs"))
{
printf("\n");
printf("copyoffs - copies the characters in a file from the offset (start and end)\n");
printf("           you specify to a new file.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "revcat"))
{
printf("\n");
printf("revcat   - shows a file reversed to the screen.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "qcrypt"))
{
printf("\n");
printf("qcrypt   - encrypts or decrypts a file to a new file, this does both\n");
printf("           encryption and decryption.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "revlines"))
{
printf("\n");
printf("revlines - reverses every line the file you specify to a new file.\n");
printf("\n");
exit(0);
}

else if (!strcmp(cmd, "flipcopy"))
{
printf("\n");
printf("flipcopy - copies while flipping the bits of each byte, for example\n\n");

printf("           11110000 becomes\n");
printf("           00001111\n");
printf("\n");
printf("           and\n\n");

printf("           01010101 becomes\n");
printf("           10101010 etc\n");

printf("\n");
exit(0);
}








else
{
fprintf(stderr, "\n\nUnknown help catagory: %s\n\n", cmd);
exit(8);
}


}

