/* ---------- */
/* najitool.c */
/* ---------- */

/* najitool main module */

/* this  .c  is a part of */
/* najitool version 0.5.0 */

/* from najitool version 0.2.0 and */
/* above najitool will use libnaji */
/* this version uses libnaji 0.3.0 */

/* both najitool and libnaji */
/* are public domain and are */
/* made by the same author   */
/* please read license.txt   */

/* made by NECDET COKYAZICI  */


/* ------------------- */
/* Program Exit Values */
/* ------------------- */

/* 0 - Program exited normally.
 * 1 - Too many or too few parameters.
 * 2 - Error opening input file.
 * 3 - Ouput file already exists.
 * 4 - Error opening output file.
 * 5 - Error opening second input file.
 * 6 - Error opening edit file.
 * 7 - Unknown command.
 * 8 - Help error.
 * 9 - Memory allocation error.
 */



#include "libnaji.h"
#define NAJITOOL_MAX_COMMANDS 68

void najitool_help_commands_1(void);
void najitool_help_commands_2(void);

void najitool_help_examples_1(void);
void najitool_help_examples_2(void);
void najitool_help_examples_3(void);
void najitool_help_examples_4(void);

void najitool_command_help(char *cmd);


char * najitool_valid_commands[NAJITOOL_MAX_COMMANDS] = { "help",
"kitten",   "cat_text", "freverse", "repcat",   "copyfile",
"bin2text", "bin2hexi", "rndbfile", "rndtfile", "skipcat",
"skipchar", "onlychar", "repchar",  "eng2arab", "arab2eng",
"8bit256",  "bigascii", "bigascif", "copyself", "bin2c",
"calc",     "genlic",   "license",  "database", "html_db",
"addim",    "allfiles", "dos2unix", "unix2dos", "compare",
"ccompare", "charfile", "hmakerf",  "hmaker",   "filechop",
"txt2html", "htmlfast", "tabspace", "unihtml",  "rmunihtm",
"mergline", "lcharvar", "rcharvar", "asctable", "hexicat",
"onlycat",  "najcrypt", "engnum",   "turnum",   "repcharp",
"repcatpp", "fillfile", "rndffill", "strfile",  "zerokill",
"randkill", "najisum",  "rndbsout", "rndtsout", "putlines",
"naji_bmp", "coffset",  "copyoffs", "revcat",   "qcrypt",
"revlines", "flipcopy"
};

void najitool_check_command(char *cmd)
{
int i;

 for (i=0; i<NAJITOOL_MAX_COMMANDS; i++)
 {

  if (!strcmp(cmd, najitool_valid_commands[i]))
  {
#ifdef NAJI_DEBUG
 fprintf(stderr, "\n\nNAJI_DEBUG - VALID COMMAND: %s\n\n", cmd);
 fgetc(stdin);
#endif
  return;
  }

 }

fprintf(stderr, "\nError, unknown command: %s\n\n", cmd);
exit(7);
}




void naji_stdin_msg(void)
{
    fprintf(stderr, "\nTaking input from standard input,\n");
    fprintf(stderr, "usually keyboard.\n\n");
    fprintf(stderr, "On most systems you can quit with\n");
    fprintf(stderr, "pressing Ctrl and C at the same time.\n");
}



int main(int argc, char *argv[])
{
unsigned int repeat=0;
unsigned long int size=0;
unsigned long int size2=0;
char *end;

int i;

char are_you_sure[100];

#ifdef NAJI_DEBUG
    fprintf(stderr, "\n\nNAJI_DEBUG - YOUR PARAMETERS/ARGUMENTS:\n\n");
    
    for (i=0; i<argc; i++)
    fprintf(stderr, "%s ", argv[i]);
    
    fprintf(stderr, "\n\n");

    fgetc(stdin);
#endif /* NAJI_DEBUG */


    if (argc >= 2)
    najitool_check_command(argv[1]);

    if (argc == 2)
    {
        /*********/
        if (!strcmp(argv[1], "bigascii"))
        {
        fprintf(stderr, "\n\nbigascii: Not enough parameters.\n\n");
        return 1;
        }


        if (!strcmp(argv[1], "asctable"))
        {
        asctable();
        return 0;
        }

        if (!strcmp(argv[1], "engnum"))
        {
        engnum();
        return 0;
        }

        if (!strcmp(argv[1], "turnum"))
        {
        turnum();
        return 0;
        }

        if (!strcmp(argv[1], "najcrypt"))
        {
        najcrypt();
        return 0;
        }

        if (!strcmp(argv[1], "database"))
        {
        naji_database();
        return 0;
        }

        if (!strcmp(argv[1], "html_db"))
        {
        naji_html_database();
        return 0;
        }

        if (!strcmp(argv[1], "calc"))
        {
        naji_calc();
        return 0;
        }


        if (!strcmp(argv[1], "license"))
        {
        naji_license();
        return 0;
        }

        if (!strcmp(argv[1], "naji_bmp"))
        {
        naji_bmp();
        return 0;
        }

        if (!strcmp(argv[1], "unihtml"))
        {
        naji_gen_unicode_html_pages();
        return 0;
        }
    
        if (!strcmp(argv[1], "rmunihtm"))
        {
        naji_del_gen_unicode_html_pages();
        return 0;
        }
    
        if (!strcmp(argv[1], "cat_text"))
        {
        naji_stdin_msg();
        cat_text_stdin();
        return 0;
        }

        if (!strcmp(argv[1], "kitten"))
        {
        naji_stdin_msg();
        kitten_stdin();
        return 0;
        }

        if (!strcmp(argv[1], "genlic"))
        {
        naji_genlic();
        return 0;
        }


        if (!strcmp(argv[1], "help"))
        {
        printf("\n\nAvailable help catagories:\n\n");
        printf("examples\n");
        printf("commands\n");

        printf("\n\n");
        return 0;
        }

    } /* if (argc == 2) */


    if (argc == 3)
    {

        if (!strcmp(argv[1], "help"))
        {

            if (!strcmp(argv[2], "examples"))
            {
            printf("\n\nAvaiable examples pages:\n\n");
            printf("1\n");
            printf("2\n");
            printf("3\n");
            printf("4\n");

            printf("\n\n");
            return 0;
            }
            else if (!strcmp(argv[2], "commands"))
            {
            printf("\n\nAvailable commands pages:\n\n");
            printf("1\n");
            printf("2\n");

            printf("\n\n");
            return 0;
            }


            else najitool_command_help(argv[2]);


        }

    } /* if (argc == 3) */


    if ( (argc >= 4) && (!strcmp(argv[1], "help")) )
    {

        if (!strcmp(argv[2], "examples"))
        {

            if (!strcmp(argv[3], "1"))
            najitool_help_examples_1();
    
            else if (!strcmp(argv[3], "2"))
            najitool_help_examples_2();

            else if (!strcmp(argv[3], "3"))
            najitool_help_examples_3();

            else if (!strcmp(argv[3], "4"))
            najitool_help_examples_4();
        
            else
            {
            fprintf(stderr, "\n\nUnknown examples page: %s\n\n", argv[3]);
            return 7;
            }
        }

        if (!strcmp(argv[2], "commands"))
        {

            if (!strcmp(argv[3], "1"))
            najitool_help_commands_1();
    
            else if (!strcmp(argv[3], "2"))
            najitool_help_commands_2();
        
            else
            {
            fprintf(stderr, "\n\nUnknown commands page: %s\n\n", argv[3]);
            return 7;
            }
        }
    
    return 0;
    }


    if ((argc < 3) || (argc > 7))
    {
    printf("\n\n");
    printf("******************************************\n");
    printf("    najitool 0.5.0 using libnaji 0.3.0    \n");
    printf("     both written by NECDET COKYAZICI     \n");
    printf("  No warranty, to view the license type:  \n");
    printf("             najitool license             \n");
    printf("******************************************\n\n");

    printf("         http://najitool.sf.net/          \n\n");

    printf("sorry, wrong paramaters, you used: ");
    for (i=0; i<argc; i++)
    printf("%s ", argv[i]);

    printf("\n\n");
    printf("Type the following for help:\n\n");

    printf("najitool help examples 1\n");
    printf("najitool help examples 2\n");
    printf("najitool help examples 3\n");
    printf("najitool help examples 4\n");
    printf("\n");
    printf("najitool help commands 1\n");
    printf("najitool help commands 2\n");
    printf("\n");
    printf("najitool help <command>\n");


    printf("\n");

    return 1;
    }


    if (argc == 7)
    {

        if (!strcmp(argv[1], "mergline"))
        {
        mergline(argv[2], argv[3], argv[4], argv[5], argv[6]);
        return 0;
        }
    
    }


    if (argc == 6)
    {

        if (!strcmp(argv[1], "filechop"))
        {
        filechop( (strtol(argv[2], &end, 0)), argv[3], argv[4], argv[5]);
        return 0;
        }
        
        if (!strcmp(argv[1], "putlines"))
        {
        putlines(argv[2], argv[3], argv[4], argv[5]);
        return 0;
        }

        if (!strcmp(argv[1], "copyoffs"))
        {
        size  = strtoul(argv[3], &end, 0);
        size2 = strtoul(argv[4], &end, 0);
        copyoffs(argv[2], size, size2, argv[5]);
        return 0;
        }


    }

    if (argc == 5)
    {

        if (!strcmp(argv[1], "skipchar"))
        {
        skipchar(argv[2], argv[3], argv[4]);
        return 0;
        }

        if (!strcmp(argv[1], "onlychar"))
        {
        onlychar(argv[2], argv[3], argv[4]);
        return 0;
        }

        if (!strcmp(argv[1], "repchar"))
        {
        repeat = (unsigned int) atoi(argv[4]);
        repchar(argv[2], argv[3], repeat);
        return 0;
        }

        if (!strcmp(argv[1], "repcharp"))
        {
        repeat = (unsigned int) atoi(argv[4]);
        repcharp(argv[2], argv[3], repeat);
        return 0;
        }


        if (!strcmp(argv[1], "coffset"))
        {
        size  = strtoul(argv[3], &end, 0);
        size2 = strtoul(argv[4], &end, 0);
        coffset(argv[2], size, size2);
        return 0;
        }


        if (!strcmp(argv[1], "bin2c"))
        {
        bin2c(argv[2], argv[3], argv[4]);
        return 0;
        }
        
        if (!strcmp(argv[1], "charfile"))
        {
        repeat = (unsigned int) atoi(argv[3]);
        charfile(argv[2], repeat, argv[4][0]);
        return 0;
        }

        if (!strcmp(argv[1], "strfile"))
        {
        repeat = (unsigned int) atoi(argv[3]);
        strfile(argv[2], repeat, argv[4]);
        return 0;
        }

        if (!strcmp(argv[1], "tabspace"))
        {
        repeat = atoi(argv[2]);
        tabspace(repeat, argv[3], argv[4]);
        return 0;
        }
        
    } /* if (argc == 5) */

    if (argc == 4)
    {

        if (!strcmp(argv[1], "8bit256"))
        {
        repeat = (unsigned int) atoi(argv[3]);
        _8bit256(argv[2], repeat);
        return 0;
        }

        if (!strcmp(argv[1], "eng2arab"))
        {
        eng2arab(argv[2], argv[3]);
        return 0;
        }

        if (!strcmp(argv[1], "arab2eng"))
        {
        arab2eng(argv[2], argv[3]);
        return 0;
        }

        if (!strcmp(argv[1], "e2ahtml"))
        {
        e2ahtml(argv[2], argv[3]);
        return 0;
        }

        if (!strcmp(argv[1], "freverse"))
        {
        freverse(argv[2], argv[3]);
        return 0;
        }

        if (!strcmp(argv[1], "repcat"))
        {
        repeat = (unsigned int) atoi(argv[3]);
        repcat(argv[2], repeat);
        return 0;
        }

        if (!strcmp(argv[1], "repcatpp"))
        {
        repeat = (unsigned int) atoi(argv[3]);
        repcatpp(argv[2], repeat);
        return 0;
        }

        if (!strcmp(argv[1], "copyfile"))
        {
        copyfile(argv[2], argv[3]);
        return 0;
        }

        if (!strcmp(argv[1], "flipcopy"))
        {
        flipcopy(argv[2], argv[3]);
        return 0;
        }


        if (!strcmp(argv[1], "fillfile"))
        {
        fillfile(argv[2], argv[3][0]);
        return 0;
        }

        if (!strcmp(argv[1], "bin2text"))
        {
        bin2text(argv[2], argv[3]);
        return 0;
        }
        
        if (!strcmp(argv[1], "bin2hexi"))
        {
        bin2hexi(argv[2], argv[3]);
        return 0;
        }

        if (!strcmp(argv[1], "rndbfile"))
        {
        size = strtoul(argv[3], &end, 0);
        rndbfile(argv[2], size);
        return 0;
        }
    
        if (!strcmp(argv[1], "rndtfile"))
        {
        size = strtoul(argv[3], &end, 0);
        rndtfile(argv[2], size);
        return 0;
        }

        if (!strcmp(argv[1], "skipcat"))
        {
        skipcat(argv[2], argv[3]);
        return 0;
        }

        if (!strcmp(argv[1], "onlycat"))
        {
        onlycat(argv[2], argv[3]);
        return 0;
        }
        
        if (!strcmp(argv[1], "bigascif"))
        {
        bigascif(argv[2], argv[3]);
        return 0;
        }

        if (!strcmp(argv[1], "unix2dos"))
        {
        unix2dos(argv[2], argv[3]);
        return 0;
        }

        if (!strcmp(argv[1], "dos2unix"))
        {
        dos2unix(argv[2], argv[3]);
        return 0;
        }
        
        if (!strcmp(argv[1], "compare"))
        {
        compare(argv[2], argv[3]);
        return 0;
        }

        if (!strcmp(argv[1], "ccompare"))
        {
        ccompare(argv[2], argv[3]);
        return 0;
        }
        
        if (!strcmp(argv[1], "hmakerf"))
        {
        hmakerf(argv[2], argv[3]);
        return 0;
        }

        if (!strcmp(argv[1], "qcrypt"))
        {
        qcrypt(argv[2], argv[3]);
        return 0;
        }

        if (!strcmp(argv[1], "revlines"))
        {
        revlines(argv[2], argv[3]);
        return 0;
        }
        
        if (!strcmp(argv[1], "txt2html"))
        {
        txt2html(argv[2], argv[3]);
        return 0;
        }

        if (!strcmp(argv[1], "htmlfast"))
        {
        htmlfast(argv[2], argv[3]);
        return 0;
        }

    } /* if (argc == 4) */

        if (argc == 3)
        {

            if (!strcmp(argv[1], "lcharvar"))
            {
            lcharvar(argv[2]);
            return 0;
            }


            if (!strcmp(argv[1], "rcharvar"))
            {
            rcharvar(argv[2]);
            return 0;
            }


            if (!strcmp(argv[1], "cat_text"))
            {
            cat_text(argv[2]);
            return 0;
            }

            if (!strcmp(argv[1], "hexicat"))
            {
            hexicat(argv[2]);
            return 0;
            }

            if (!strcmp(argv[1], "rndffill"))
            {
            rndffill(argv[2]);
            return 0;
            }

            if (!strcmp(argv[1], "zerokill"))
            {
            zerokill(argv[2]);
            return 0;
            }

            if (!strcmp(argv[1], "randkill"))
            {
            randkill(argv[2]);
            return 0;
            }

            if (!strcmp(argv[1], "najisum"))
            {
            najisum(argv[2]);
            return 0;
            }

            if (!strcmp(argv[1], "rndbsout"))
            {
            size = strtoul(argv[2], &end, 0);
            rndbsout(size);
            return 0;
            }

            if (!strcmp(argv[1], "rndtsout"))
            {
            size = strtoul(argv[2], &end, 0);
            rndtsout(size);
            return 0;
            }

            if (!strcmp(argv[1], "kitten"))
            {
            kitten(argv[2]);
            return 0;
            }

            if (!strcmp(argv[1], "revcat"))
            {
            revcat(argv[2]);
            return 0;
            }

            if (!strcmp(argv[1], "copyself"))
            {
            copyfile(argv[0], argv[2]);
            return 0;
            }

            if (!strcmp(argv[1], "bigascii"))
            {
            bigascii(argv[2]);
            return 0;
            }
            
            if (!strcmp(argv[1], "hmaker"))
            {
            hmaker(argv[2]);
            return 0;
            }
        
            if (!strcmp(argv[1], "wrdcount"))
            {
            printf("\n\n%i\n\n", wrdcount(argv[2]));
            return 0;
            }
        
            if (!strcmp(argv[1], "addim"))
            {
            addim(atoi(argv[2]));
            return 0;
            }
        
            if (!strcmp(argv[1], "allfiles"))
            {
            fprintf(stderr, "\nOn most systems you can stop with Ctrl+C\n");
            fprintf(stderr, "WARNING: This will make a lot of files.\n");
            fprintf(stderr, "Are you sure? type YES to continue\n");
            fprintf(stderr, "or anything else to quit.\n");
            safegets(are_you_sure, 80);
            
            if (!strcmp(are_you_sure, "YES"))
            allfiles(atoi(argv[2]));
            return 0;
            }
        
        } /* if (argc == 3) */


return 0;         
}

